package com.bjsxt.server;

import com.bjsxt.servlet.Servlet;
import com.bjsxt.util.IOCloseUtil;

import java.io.IOException;
import java.net.Socket;
/*一个请求与响应就是一个Dispatcher
*/

public class Dispatcher implements Runnable {
    private Request req;
    private Response rep;
    private Socket client;
    private int code=200;//状态码默认初始是200
    //构造方法初始化属性
    public Dispatcher(Socket client){
        //将局部变量的值赋给成员变量
        this.client=client;
        try {
            req=new Request(this.client.getInputStream());
            rep=new Response(this.client.getOutputStream());
        } catch (IOException e) {
            code=500;
            return;
        }
    }
    @Override
    public void run() {
        //根据不同的url获取指定的servlet对象
        //System.out.println(req.getUrl());
        Servlet servlet =WebApp.getServlet(req.getUrl());
        if (servlet==null){
            this.code=404;
        }else {
            //调用相应的servlet中的2service方法
            try {
                servlet.service(req,rep);
            } catch (Exception e) {
                this.code=500;
            }
        }
        //将响应结果推送到客户机的浏览器
        rep.pushToClient(code);
        IOCloseUtil.closeAll(client);
    }
}
