package com.bjsxt.server;

import com.bjsxt.servlet.Servlet;

import javax.imageio.stream.ImageInputStream;
import java.util.List;
import java.util.Map;

public class WebApp {//App的意思是应用程序
    private static ServletContext context;
    static {
        context=new ServletContext();
        //分别获取对应关系的Map集合
        Map<String,String> servlet=context.getServlet();
        Map<String,String> mapping=context.getMapping();
        //创建解析XML文件对象
        WebDom4j web=new WebDom4j();
        web.parse(web.getDocument());//解析xml
        //获取解析xml之后的list集合
        List<Entity>entityList =web.getEntityList();
        List<Mapping>mappingList= web.getMappingList();

        //将list集合中的数据储存到map集合
        for (Entity entity:entityList){
            servlet.put(entity.getName(),entity.getClazz());
        }
        //System.out.println(servlet);
        for (Mapping map:mappingList){
            //遍历url-pattern的集合
            List<String>urlPattern=map.getUrlPattern();
            for (String s:urlPattern){
                mapping.put(s,map.getName());
            }
        }
        //System.out.println(mapping);
    }
    /*根据url创建不同的Servlet
    * */
   public static Servlet getServlet(String url){
       if (url==null||url.trim().equals("")){
           return null;
       }
       Servlet servlet= null;
       try {
           //如果url正确
           //根据url的key获取servlet-name的值  /log=login,/reg=register
           String servletName=context.getMapping().get(url);
           //根据servlentName的servlet-class
           String servletClass=context.getServlet().get(servletName);
           //使用反射创建Servlet对象
           Class<?>clazz=Class.forName(servletClass);
           //调用无参构造方法创建Servlet对象
           servlet = (Servlet)clazz.newInstance();
           return servlet;
       } catch (ClassNotFoundException e) {
           e.printStackTrace();
       } catch (InstantiationException e) {
           e.printStackTrace();
       } catch (IllegalAccessException e) {
           e.printStackTrace();
       }
       return null;
   }
   //测试
   public static void main(String[] args) {
       System.out.println(getServlet("/log"));
       System.out.println(getServlet("/login"));
    }
}