package com.bjsxt.server;

import org.dom4j.Document;
import org.dom4j.DocumentException;
import org.dom4j.Element;
import org.dom4j.io.SAXReader;

import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class WebDom4j {//用于解析XML
    private List<Entity>entityList;//用于储存是N多Entity，而每一个Entity都是servlet-name与servle-name与serlet-class
    private List<Mapping>mappingList;//用于储存N多个Mapping，而每一个Mapping都是一个servlet-name与N多个url-pattern


    public List<Entity> getEntityList() {
        return entityList;
    }

    public void setEntityList(List<Entity> entityList) {
        this.entityList = entityList;
    }

    public List<Mapping> getMappingList() {
        return mappingList;
    }

    public void setMappingList(List<Mapping> mappingList) {
        this.mappingList = mappingList;
    }
    //构造方法

    public WebDom4j() {
        entityList=new ArrayList<Entity>();
        mappingList=new ArrayList<Mapping>();
    }
    //获取Document对象的方法
    public Document getDocument(){
        try {
            //(1)创建SAXReader对象
            SAXReader reader=new SAXReader();
            //(2)调用read
            return reader.read(new File("http_server3/src/WEB_INFO/web.xml"));
        } catch (DocumentException e) {
            e.printStackTrace();
        }
        return null;
    }
    public void parse(Document doc){
        //(1)获取根元素
        Element root= doc.getRootElement();//web-app
        //(2)获取servlet子元素
        for (Iterator<Element>ite =root.elementIterator("servlet"); ite.hasNext();){
            Element subElement=ite.next();//得到每一个servlet
            //创建一个实体类
            Entity ent=new Entity();//用于储存servlet-name与servlet-class
            for (Iterator<Element>subIte=subElement.elementIterator();subIte.hasNext();){
                Element ele=subIte.next();//可能是servlet-name,也可能是servlet-class
                if ("servlet-name".equals(ele.getName())){
                    ent.setName(ele.getText());//给实体类中的name赋值
                }else if ("servlet-class".equals(ele.getName())){
                    ent.setClazz(ele.getText());
                }
            }
            //将Entity添加到集合中
            entityList.add(ent);
        }
        //测试
        /*for (Entity entity:entityList) {
            System.out.println(entity.getName()+"\t"+entity.getClazz());
        }*/
        //解析servletMapping
        for (Iterator<Element>ite=root.elementIterator("servlet-mapping");ite.hasNext();){
            Element subEle=ite.next();//得到每一个servlet-mapping
            //创建一个Mapping类的对象
            Mapping map=new Mapping();
            //解析servlet-mapping下的子元素
            for (Iterator<Element>subIte=subEle.elementIterator();subIte.hasNext();){
                Element ele=subIte.next();//servlet-name,也有可能是url-pattern
                if ("servlet-name".equals(ele.getName())){
                    map.setName(ele.getText());
                }else if ("url-pattern".equals(ele.getName())){
                    //获取集合对象，调用集合对象的添加方法，添加元素
                    map.getUrlPattern().add(ele.getText());
                }

            }
            //Mapping添加到集合中
            mappingList.add(map);

        }
        //测试
        /*for (Mapping m:mappingList){
            System.out.println(m.getName());
            for (String s:m.getUrlPattern()){
                System.out.println(s);
            }
        }*/
    }
    //用于测试
    public static void main(String[] args) {
        WebDom4j web=new WebDom4j();
        web.parse(web.getDocument());
    }

}
